var gStrbundle;
var gAnonymous;
var gArgs;
var gSite;
var gAutoAccount = false;

function init() {
  gStrbundle                  = $("strings");
  gArgs                       = window.arguments[0];
  gSite                       = window.arguments[0].site;
  gAnonymous                  = gSite.anonymous;

  $('account').value          = gSite.account;
  $('host').value             = gSite.host;
  $('port').value             = gSite.port;
  $('login').value            = gSite.login;
  $('password').value         = gSite.password;
  $('anonymous').checked      = gAnonymous;
  $('login').disabled         = gAnonymous;
  $('password').disabled      = gAnonymous;
  $('security').value         = gSite.security || "";
  $('pasvmode').checked       = gSite.pasvmode;
  $('ipmode').checked         = gSite.ipmode;
  $('webhost').value          = gSite.webhost  || "";
  $('prefix').value           = gSite.prefix   || "";
  $('localdir').value         = gSite.localdir;
  $('remotedir').value        = gSite.remotedir;
  $('treesync').checked       = gSite.treesync;
  $('downloadcasemode').value = gSite.downloadcasemode;
  $('uploadcasemode').value   = gSite.uploadcasemode;

  initialDirChange();

  $('host').focus();

  if (!$('account').value && !gArgs.quickConnect) {
    gAutoAccount = true;
  }

  if (gArgs.quickConnect) {                                // this is a QuickConnect, no data saved, put a Connect button in place of an Ok button
    $('accountrow').collapsed                      = true;
    $('accountManager3').getButton("accept").label = gStrbundle.getString("connectButton");
    document.title                                 = gStrbundle.getString("quickConnect");
  }
}

function autoAccount() {
  if (gAutoAccount) {
    $('account').value = $('host').value;
  }
}

function autoAccountDisable() {
  gAutoAccount = false;
}

function useCurrentLocal() {
  $('localdir').value  = gArgs.localPath;
  initialDirChange();
}

function useCurrentRemote() {
  $('remotedir').value = gArgs.remotePath;
  initialDirChange();
}

function anonymousChange() {
  gAnonymous             = !gAnonymous;
  $('login').disabled    =  gAnonymous;
  $('password').disabled =  gAnonymous;
  $('login').value       =  gAnonymous ? "anonymous"           : "";
  $('password').value    =  gAnonymous ? "fireftp@example.com" : "";
}

function initialDirChange() {
  $('treesync').disabled = !$('localdir').value || !$('remotedir').value;

  if ($('treesync').disabled) {
    $('treesync').checked = false;
  }
}

function onSecurityChange() {
  $('port').value = $('security').value == "ssl" ? 990 : 21;
}

function doOk() {
  $('host').value = $('host').value.replace(/^http:\/*/, '');
  $('host').removeAttribute('missing');
  $('account').removeAttribute('missing');

  if (!gArgs.quickConnect && ($('account').value == "" || $('host').value == "")) {
    $('tabbox').selectedIndex = 0;

    if ($('host').value == "") {
      $('host').setAttribute('missing', true);
      $('host').focus();
    }

    if ($('account').value == "") {
      $('account').setAttribute('missing', true);
      $('account').focus();
    }

    return false;
  }

  gArgs.returnVal        = true;
  gSite.account          = $('account').value;
  gSite.host             = $('host').value;
  gSite.port             = $('port').value;
  gSite.login            = $('login').value;
  gSite.password         = $('password').value;
  gSite.anonymous        = $('anonymous').checked;
  gSite.security         = $('security').value;
  gSite.pasvmode         = $('pasvmode').checked;
  gSite.ipmode           = $('ipmode').checked;
  gSite.webhost          = $('webhost').value;
  gSite.prefix           = $('prefix').value;
  gSite.localdir         = $('localdir').value;
  gSite.remotedir        = $('remotedir').value;
  gSite.treesync         = $('treesync').checked;
  gSite.downloadcasemode = $('downloadcasemode').value;
  gSite.uploadcasemode   = $('uploadcasemode').value;

  return true;
}
